/******************************************************************************/
/*                                                                            */
/*                       SUPPORT FUNCTIONS FOR IRA PORT                       */
/*                                                                            */
/******************************************************************************/

#include "ira.h"

void *AllocMem(ULONG size, ULONG flags)
{
    void *ptr;

    ptr = malloc(size);

    if(ptr!=NULL){

       if((flags & MEMF_CLEAR)!=0) memset(ptr,0x00,size);

    }

    return(ptr);
}

void FreeMem(void *ptr,ULONG cnt)
{
   if(ptr!=NULL) free(ptr);
}

// int to ascii (signed, decimal)

char *ira_itoa(ULONG ta)
{
   static char ira_itoa_buf[64];

   return itoa((int) ta, ira_itoa_buf, 10);
}

// int to ascii (signed, decimal)

char *itohex(ULONG ta, ULONG digits)
{
   static char ira_itohex_buf[64];
   char format[8];

   sprintf(format,"%%%02dX",digits);	// Make "%0?x"
   sprintf(ira_itohex_buf,format,ta);

   return ira_itohex_buf;
}

// copy size longwords from src to dst (with overlapping support)

void lmovmem(ULONG *src, ULONG *dst, ULONG size)
{
   memmove((UBYTE *) dst, (UBYTE *) src, size<<2);
}

void stcd_l(char *src, int *dest)
{
   sscanf(src,"%d",&dest[0]);
}

void stch_l(char *src, int *dest)
{
   sscanf(src,"%X",&dest[0]);
}

void strsfn(char *src, int a0, int a1, char *dst, int a2)
{
   char *p;

   strcpy(dst,src);
   if((p = strrchr (dst,'.'))){
      p[0] = 0;
   }
}

void ByteSwap(UBYTE *src, int size)
{
   int ta;
   for(ta=0;ta<size;ta+=2){
      WriteWord(&src[ta],ReadWord68k(&src[ta]));
   }
}





